# overview-client
This the API specifications for the OV20i Smart AI Camera produced by Overview Inc. It works with firmware versions above 2024.23.1.

Some useful links:
- [Overview Documentation](https://overview.ai/support)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1
- Package version: 1.0.0
- Generator version: 7.12.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import overview_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import overview_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import overview_client
from overview_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://192.168.0.100
# See configuration.py for a list of all supported configuration parameters.
configuration = overview_client.Configuration(
    host = "http://192.168.0.100"
)



# Enter a context with an instance of the API client
with overview_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = overview_client.CaptureApi(api_client)
    limit = 1 # int | Maximum number of captures to return (optional) (default to 1)
    order = captured_at.desc # str | Order of returned captures (optional) (default to captured_at.desc)
    select = 'id,captured_at,source_recipe_id,path,height,width,size,classification_result(created_at,confidence,block_classification_classes(label_name,block_roi_inspection_type_params(name)),roi_result(block_roi_region_params(name,bbox,angle)))' # str | Fields to include in the response (optional) (default to 'id,captured_at,source_recipe_id,path,height,width,size,classification_result(created_at,confidence,block_classification_classes(label_name,block_roi_inspection_type_params(name)),roi_result(block_roi_region_params(name,bbox,angle)))')

    try:
        # Get 1 or more captures according to specific parameters
        api_response = api_instance.get_captures(limit=limit, order=order, select=select)
        print("The response of CaptureApi->get_captures:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling CaptureApi->get_captures: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://192.168.0.100*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CaptureApi* | [**get_captures**](docs/CaptureApi.md#get_captures) | **GET** /postgrest/captures | Get 1 or more captures according to specific parameters
*RecipeApi* | [**activate_recipe_by_id**](docs/RecipeApi.md#activate_recipe_by_id) | **POST** /edge/recipe/activate | Activate a recipe


## Documentation For Models

 - [Capture](docs/Capture.md)
 - [CaptureClassificationResultInner](docs/CaptureClassificationResultInner.md)
 - [CaptureClassificationResultInnerBlockClassificationClasses](docs/CaptureClassificationResultInnerBlockClassificationClasses.md)
 - [CaptureClassificationResultInnerBlockClassificationClassesBlockRoiInspectionTypeParams](docs/CaptureClassificationResultInnerBlockClassificationClassesBlockRoiInspectionTypeParams.md)
 - [CaptureClassificationResultInnerRoiResult](docs/CaptureClassificationResultInnerRoiResult.md)
 - [CaptureClassificationResultInnerRoiResultBlockRoiRegionParams](docs/CaptureClassificationResultInnerRoiResultBlockRoiRegionParams.md)
 - [RecipeId](docs/RecipeId.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author

lucas.vandroux@viun.tech


