# coding: utf-8

"""
    Overview Smart AI Cameras API

    This the API specifications for the OV20i Smart AI Camera produced by Overview Inc. It works with firmware versions above 2024.23.1.  Some useful links: - [Overview Documentation](https://overview.ai/support)

    The version of the OpenAPI document: 0.0.1
    Contact: lucas.vandroux@viun.tech
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from overview_client.models.capture_classification_result_inner_block_classification_classes_block_roi_inspection_type_params import CaptureClassificationResultInnerBlockClassificationClassesBlockRoiInspectionTypeParams
from typing import Optional, Set
from typing_extensions import Self

class CaptureClassificationResultInnerBlockClassificationClasses(BaseModel):
    """
    CaptureClassificationResultInnerBlockClassificationClasses
    """ # noqa: E501
    label_name: Optional[StrictStr] = Field(default=None, description="Classification label assigned to the ROI")
    block_roi_inspection_type_params: Optional[CaptureClassificationResultInnerBlockClassificationClassesBlockRoiInspectionTypeParams] = None
    __properties: ClassVar[List[str]] = ["label_name", "block_roi_inspection_type_params"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CaptureClassificationResultInnerBlockClassificationClasses from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of block_roi_inspection_type_params
        if self.block_roi_inspection_type_params:
            _dict['block_roi_inspection_type_params'] = self.block_roi_inspection_type_params.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CaptureClassificationResultInnerBlockClassificationClasses from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "label_name": obj.get("label_name"),
            "block_roi_inspection_type_params": CaptureClassificationResultInnerBlockClassificationClassesBlockRoiInspectionTypeParams.from_dict(obj["block_roi_inspection_type_params"]) if obj.get("block_roi_inspection_type_params") is not None else None
        })
        return _obj


